class cpp_test_spinlock {
	volatile bool lockBool = 0;

  public:
	inline void lock() {
		for ( ;; ) {
			if ( (this->lockBool == 0) && (__atomic_test_and_set( &this->lockBool, __ATOMIC_ACQUIRE ) == 0) ) break;
		}
	}

	inline bool try_lock() {
		return (this->lockBool == 0) && (__atomic_test_and_set( &this->lockBool, __ATOMIC_ACQUIRE ) == 0);
	}

	inline void unlock() {
		__atomic_clear( &this->lockBool, __ATOMIC_RELEASE );
	}
};

inline void lock( cpp_test_spinlock &a, cpp_test_spinlock &b ) {
    a.lock(); b.lock();
}
inline void lock( cpp_test_spinlock &a, cpp_test_spinlock &b, cpp_test_spinlock &c, cpp_test_spinlock &d ) {
    a.lock(); b.lock(); c.lock(); d.lock();
}
inline void lock( cpp_test_spinlock &a, cpp_test_spinlock &b, cpp_test_spinlock &c, cpp_test_spinlock &d, cpp_test_spinlock &e, cpp_test_spinlock &f, cpp_test_spinlock &g, cpp_test_spinlock &h ) {
    a.lock(); b.lock(); c.lock(); d.lock(); e.lock(); f.lock(); g.lock(); h.lock();
}
inline void unlock( cpp_test_spinlock &a, cpp_test_spinlock &b ) {
    a.unlock(); b.unlock();
}
inline void unlock( cpp_test_spinlock &a, cpp_test_spinlock &b, cpp_test_spinlock &c, cpp_test_spinlock &d ) {
    a.unlock(); b.unlock(); c.unlock(); d.unlock();
}
inline void unlock( cpp_test_spinlock &a, cpp_test_spinlock &b, cpp_test_spinlock &c, cpp_test_spinlock &d, cpp_test_spinlock &e, cpp_test_spinlock &f, cpp_test_spinlock &g, cpp_test_spinlock &h ) {
    a.unlock(); b.unlock(); c.unlock(); d.unlock(); e.unlock(); f.unlock(); g.unlock(); h.unlock();
}